<?php
if (! defined ( 'sugarEntry' ) || ! sugarEntry)
	die ( 'Not A Valid Entry Point' );
/**
 * ***************************************************************************
 * The contents of this file are subject to the RECIPROCAL PUBLIC LICENSE
 * Version 1.1 ("License"); You may not use this file except in compliance
 * with the License.
 * You may obtain a copy of the License at
 * http://opensource.org/licenses/rpl.php. Software distributed under the
 * License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND,
 * either express or implied.
 *
 * You may:
 * a) Use and distribute this code exactly as you received without payment or
 * a royalty or other fee.
 * b) Create extensions for this code, provided that you make the extensions
 * publicly available and document your modifications clearly.
 * c) Charge for a fee for warranty or support or for accepting liability
 * obligations for your customers.
 *
 * You may NOT:
 * a) Charge for the use of the original code or extensions, including in
 * electronic distribution models, such as ASP (Application Service
 * Provider).
 * b) Charge for the original source code or your extensions other than a
 * nominal fee to cover distribution costs where such distribution
 * involves PHYSICAL media.
 * c) Modify or delete any pre-existing copyright notices, change notices,
 * or License text in the Licensed Software
 * d) Assert any patent claims against the Licensor or Contributors, or
 * which would in any way restrict the ability of any third party to use the
 * Licensed Software.
 *
 * You must:
 * a) Document any modifications you make to this code including the nature of
 * the change, the authors of the change, and the date of the change.
 * b) Make the source code for any extensions you deploy available via an
 * Electronic Distribution Mechanism such as FTP or HTTP download.
 * c) Notify the licensor of the availability of source code to your extensions
 * and include instructions on how to acquire the source code and updates.
 * d) Grant Licensor a world-wide, non-exclusive, royalty-free license to use,
 * reproduce, perform, modify, sublicense, and distribute your extensions.
 *
 * The Original Code is: CommuniCore
 * Olavo Farias
 * 2006-04-7 olavo.farias@gmail.com
 *
 * The Initial Developer of the Original Code is CommuniCore.
 * Portions created by CommuniCore are Copyright (C) 2005 CommuniCore Ltda
 * All Rights Reserved.
 * ******************************************************************************
 */
require_once ('data/SugarBean.php');
require_once ('include/utils.php');
class EcmInvoiceOut extends SugarBean {
	var $field_name_map = array ();
	// STANDARD FIELDS
	var $id;
	var $date_entered;
	var $date_modified;
	var $modified_user_id;
	var $assigned_user_id;
	var $name;
	var $description;
	// TABLE COLUMNS
	var $number;
	var $document_no;
	var $parent_type;
	var $parent_name;
	var $parent_id;
	var $type;
	var $status;
	var $register_date;
	var $parent_address_street;
	var $parent_address_city;
	var $parent_address_postalcode;
	var $parent_address_country;
	var $subtotal;
	var $total;
	var $discount;
	var $to_vatid;
	var $ecmlanguage;
	var $to_is_vat_free;
	var $header_text;
	var $footer_text;
	var $ads_text;
	var $template_id;
	var $template_name;
	var $email_id;
	var $parent_name_copy;
	var $parent_contact_name;
	var $parent_contact_title;
	var $ecmpaymentcondition_id;
	var $ecmpaymentcondition_name;
	var $ecmpaymentcondition_text;
	var $ecmdeliverycondition_id;
	var $ecmdeliverycondition_name;
	var $ecmdeliverycondition_text;
	var $validtill_date;
	var $order_origin;
	var $contact_id;
	var $contact_name;
	var $show_images_on_offers;
	var $currency_symbol;
	var $currency_id;
	var $show_ean;
	var $template;
	var $pdf;
	var $position_list;
	var $parser;
	var $account;
	var $contact;
	var $user;
	var $mfp;
	// added 4.03.2009
	var $pricebook_id;
	var $show_recipient_code;
	// RELATED FIELDS
	var $created_by;
	var $created_by_name;
	var $modified_by_name;
	var $assigned_user_name;
	// SUBPANELS RELATED
	// MODULE OBJECT DETAILS
	var $module_dir = "EcmInvoiceOuts";
	var $table_name = "ecminvoiceouts";
	var $object_name = "EcmInvoiceOut";
	// RELATED TABLE NAMES
	// USED TO RETRIEVE RELATED FIELDS FROM FORM POSTS.
	var $additional_column_fields = Array (
			'assigned_user_name',
			'assigned_user_id',
			'modified_user_id',
			'created_by' 
	);
	// RELATIONSHIP FIELDS
	var $relationship_fields = Array (
			'note_id' => 'notes',
			'email_id' => 'emails' 
	)
	// 'account_id' => 'account',
	// 'contact_id' => 'contact',
	;
	function EcmInvoiceOut() {
		parent::SugarBean ();
		$this->setupCustomFields ( 'EcmInvoiceOuts' );
		foreach ( $this->field_defs as $field ) {
			$this->field_name_map [$field ['name']] = $field;
		}
	}
	var $new_schema = true;
	function get_summary_text() {
		return "$this->name";
	}
	function create_list_query($order_by, $where, $show_deleted = 0) {
		// Fill in the assigned_user_name
		$custom_join = $this->custom_fields->getJOIN ();
		$query = "SELECT ";
		$query .= "ecminvoiceouts.*
                  ,users.user_name as assigned_user_name";
		if ($custom_join) {
			$query .= $custom_join ['select'];
		}
		$query .= " FROM ecminvoiceouts 
                   LEFT JOIN users
                   ON ecminvoiceouts.assigned_user_id=users.id";
		$query .= "  ";
		if ($custom_join) {
			$query .= $custom_join ['join'];
		}
		$where_auto = '1=1';
		if ($show_deleted == 0) {
			$where_auto = " $this->table_name.deleted=0 ";
		} else if ($show_deleted == 1) {
			$where_auto = " $this->table_name.deleted=1 ";
		}
		if ($where != "")
			$query .= "where $where AND " . $where_auto;
		else
			$query .= "where " . $where_auto;
		if (substr_count ( $order_by, '.' ) > 0) {
			$query .= " ORDER BY $order_by";
		} else if ($order_by != "")
			$query .= " ORDER BY $order_by";
		else
			$query .= " ORDER BY ecminvoiceouts.name";
		return $query;
	}
	function create_export_query($order_by, $where) {
		$custom_join = $this->custom_fields->getJOIN ();
		$query = "SELECT
                      ecminvoiceouts.*,
                      users.user_name assigned_user_name";
		if ($custom_join) {
			$query .= $custom_join ['select'];
		}
		$query .= " FROM ecminvoiceouts ";
		$query .= " LEFT JOIN users
                  ON ecminvoiceouts.assigned_user_id=users.id";
		if ($custom_join) {
			$query .= $custom_join ['join'];
		}
		$query .= "";
		$where_auto = " ecminvoiceouts.deleted=0 
                    ";
		if ($where != "")
			$query .= " where $where AND " . $where_auto;
		else
			$query .= " where " . $where_auto;
		if ($order_by != "")
			$query .= " ORDER BY $order_by";
		else
			$query .= " ORDER BY ecminvoiceouts.name";
		return $query;
	}
	function fill_in_additional_list_fields() {
	}
	function check_mail_addresses(){
	    $sea = new SugarEmailAddress;
	    $addresses = $sea->getAddressesByGUID($this->parent_id, 'Accounts');
	    $check=0;
	    foreach ( $addresses as $address ) {
	        if($address['email_address']!='' && $address['opt_out']==1){
	            $check=1;
	        } 
	    }
	    return $check;
	}
	function fill_in_additional_detail_fields() {
		// FILL IN THE ASSIGNED_USER_NAME
		$this->assigned_user_name = get_assigned_user_name ( $this->assigned_user_id );
		$this->created_by_name = get_assigned_user_name ( $this->created_by );
		$this->modified_by_name = get_assigned_user_name ( $this->modified_user_id );
		/*
		 * $result = $this->db->query ( "SELECT status, parent_id, contact_id, template_id, assigned_user_id FROM ecminvoiceouts WHERE id='$this->id'" );
		 * if (is_resource ( $result )) {
		 * $row = $this->db->fetchByAssoc ( $result );
		 * if ($row) {
		 * $this->status = $row ['status'];
		 * $this->parent_id = $row ['parent_id'];
		 * $this->contact_id = $row ['contact_id'];
		 * $this->template_id = $row ['template_id'];
		 * $this->assigned_user_id = $row ['assigned_user_id'];
		 * }
		 * }
		 */
		/*
		 * $query = "select `number`, `template_id` from `ecminvoiceouts` where `id`='$this->id' limit 1"; $r = $this->db->query($query); if($r) { $r = $this->db->fetchByAssoc($r); $this->template_id = $r['template_id']; $this->number = $r['number']; $this->setTemplate(); $this->document_no = $this->formatNumber(); }
		 */
	}
	function get_list_view_data() {
		global $current_language;
		$this->fill_in_additional_detail_fields ();
		$app_list_strings = return_app_list_strings_language ( $current_language );
		$mod_strings = return_module_language ( $current_language, 'EcmInvoiceOuts' );
		$the_array = parent::get_list_view_data ();
		// THE NEW LISTVIEW CODE ONLY FETCHES COLUMNS THAT WE'RE DISPLAYING AND NOT ALL
		// THE COLUMNS SO WE NEED THESE CHECKS.
		$this->retrieve ( $this->id );
		$the_array ['NAME'] = (($this->name == "") ? "<em>blank</em>" : $this->name);
		$the_array ['PARENT_NAME'] = '<a href="index.php?module=Accounts&action=DetailView&record=' . $this->parent_id . '">' . $this->parent_name . '</a>';
		// $the_array ['TOTAL'] = format_number ( $this->total_netto );
		// create image options
		$op = '<a href="index.php?module=EcmInvoiceOuts&action=createPDF&to_pdf=1&show_img=1&show_ean=0&show_ean2=0&show_recipient_code=0&record=' . $this->id . '" target="new"/><img src="modules/EcmInvoiceOuts/images/pdf.gif"/></a>';
		$the_array ['OPTIONS'] = $op;
		
		return $the_array;
	}
	function getStatusMenuInfo($inJSON = true) {
		global $app_list_strings;
		$arr = array ();
		foreach ( $app_list_strings ['ecminvoiceouts_status_dom'] as $key => $value ) {
			$arr [$key] = array (
					'enabled' => '<div><img src="modules/EcmInvoiceOuts/images/' . $key . '.gif" />' . $value . '</div>',
					'disabled' => '<div><img src="modules/EcmInvoiceOuts/images/' . $key . '.gif" />' . $value . '</div>' 
			);
		}
		$json = getJSONobj ();
		if ($inJSON)
			return str_replace ( '&quot;', '\"', $json->encode ( $arr ) );
		else
			return $arr;
	}
	function create_new_list_query($order_by, $where, $filter = array(), $params = array(), $show_deleted = 0, $join_type = '', $return_array = false, $parentbean, $singleSelect = false) {
		echo '<script type="text/javascript" src="include/ECM/EcmPreviewPDF/EcmPreviewPDF.js"></script>';
		echo '<script type="text/javascript" src="modules/EcmInvoiceOuts/ListView.js"></script>';
		echo '<link rel="stylesheet" type="text/css" href="modules/EcmInvoiceOuts/ListView.css" />';
		echo '<script language="javascript"> var EcmInvoiceOutsStatusMenu = ' . $this->getStatusMenuInfo () . '; </script>';
		return parent::create_new_list_query ( $order_by, $where, $filter, $params, $show_deleted, $join_type, $return_array, $parentbean, $singleSelect );
	}
	static function CreateImgStatus($id, $status) {
		global $app_list_strings;
		return '<span id="statusListEcmInvoiceOut_' . $id . '" style="display:inline;"><img src="modules/EcmInvoiceOuts/images/' . $status . '.gif" title="' . $app_list_strings ['ecminvoiceouts_status_dom'] [$status] . '" /></span>';
	}
	
	/**
	 * BUILDS A GENERIC SEARCH BASED ON THE QUERY STRING USING OR.
	 * DO NOT INCLUDE ANY $THIS-> BECAUSE THIS IS CALLED ON WITHOUT HAVING THE CLASS INSTANTIATED.
	 */
	function build_generic_where_clause($the_query_string) {
		$where_clauses = Array ();
		$the_query_string = PearDatabase::quote ( from_html ( $the_query_string ) );
		array_push ( $where_clauses, "ecminvoiceouts.name like '$the_query_string%'" );
		$the_where = "";
		foreach ( $where_clauses as $clause ) {
			if ($the_where != "")
				$the_where .= " or ";
			$the_where .= $clause;
		}
		return $the_where;
	}
	function set_notification_body($xtpl, $simplemodule) {
		global $mod_strings, $app_list_strings;
		$xtpl->assign ( "NAME", $simplemodule->name );
		$xtpl->assign ( "DESCRIPTION", $simplemodule->description );
		return $xtpl;
	}
	function bean_implements($interface) {
		switch ($interface) {
			case 'ACL' :
				return true;
		}
		return false;
	}
	function save($check_notify = FALSE) {
		global $current_user;
		
		if (! $this->id || $this->id == '') {
			
			// generate number
			//$this->number = $this->generateNumber ( $this->stock_id );
			//$this->document_no = $this->formatNumber ( $this->number, $this->stock_id );
			if ($this->paid_val == '')
				$this->paid_val = 0;
		}
		if ($_REQUEST ['is_correct'] != '') {
			$this->number = $this->generateNumberCorrect ();
			$this->document_no = $this->formatNumberCorrect ( $this->number );
			$this->ecminvoiceout_id = $this->id;
			$r = $this->db->query ( "select document_no from ecminvoiceouts where id='" . $this->id . "'" );
			$w = $this->db->fetchByAssoc ( $r );
			$this->ecminvoiceout_name = $w ['document_no'];
			$this->id = null;
		}
		
		$this->vats_summary = htmlspecialchars ( $this->vats_summary );
		
		$return_id = parent::save ( $check_notify );
		
		$this->savePositions ( $return_id );
		if ($_REQUEST ['is_correct'] != '') {
			$this->calculateCorrectTotals ( $return_id );
		} else {
			$this->calculateTotals ( $return_id );
		}
		$db=$this->db;
		$res_count = $db->query ( "select id from ecmtransactions where record_id='" . $return_id . "' and deleted='0'" );
		$count = $res_count->num_rows;
		echo $count.' '.$return_id;
		if ($count == 0) {
			
		 $GLOBALS ['db']->query ( "INSERT INTO ecmtransactions(id,name,date_entered,date_modified,modified_user_id,created_by,description,deleted,assigned_user_id,value,parent_name,parent_id,payment_date,type,paid,register_date,record_id,record_type,currency_id,currency_value)VALUES
		            ('" . create_guid () . "','" . $this->document_no . "','" . date ( "Y-m-d H:i:s" ) . "','" . date ( "Y-m-d H:i:s" ) . "','" . $_SESSION ['authenticated_user_id'] . "','" . $_SESSION ['authenticated_user_id'] . "','" . $this->description . "','" . $this->deleted . "','" . $this->assigned_user_id . "','" . $this->total_brutto . "','" . $this->parent_name . "','" . $this->parent_id . "','" . $this->payment_date . "','0','" . $this->paid_val . "','" . $this->register_date . "','" . $return_id . "','EcmInvoiceOuts','" . $this->currency_id . "','" . $this->currency_value_nbp . "')" );
		} else {
		 
			 $db->query ( "update ecmtransactions set value='" . $total_brutto . "' where record_id='" . $return_id . "'" );
		}
	
		return $return_id;
	}
	function saveTransaction($id) {
		global $current_user;
		
		$t = new EcmTransaction ();
		$t->name = $this->document_no;
		$t->parent_name = 'EcmInvoiceOuts';
		$t->created_by = $current_user->id;
		$t->deleted = 0;
		$t->assigned_user_id = $this->assigned_user_id;
		$t->parent_name = $this->parent_name;
		$t->parent_id = $this->parent_id;
		$t->payment_date = $this->payment_date;
		$t->type = 0;
		$t->register_date = $this->register_date;
		$t->currency_id = $this->currency_id;
		$t->currency_value = $this->currency_value;
		$t->value = $this->total_brutto;
		$t->save ();
	}
	function calculateCorrectTotals($id) {
		$vats_summary = '';
		$total_netto = 0;
		$total_brutto = 0;
		$total_vat = 0;
		
		$res = $GLOBALS ['db']->query ( "select ROUND(sum(total_netto_corrected),2) AS total_netto,ROUND(sum((total_netto_corrected*ecmvat_value)/100),2) AS total_vat,
ROUND(sum(((total_netto_corrected*ecmvat_value)/100)+total_netto_corrected),2) AS total_brutto,ecmvat_value
from ecminvoiceoutitems where ecminvoiceout_id='" . $id . "' group by ecmvat_id" );
		while ( $cc = $GLOBALS ['db']->fetchByAssoc ( $res ) ) {
			$total_netto += $cc ['total_netto'];
			$total_brutto += $cc ['total_brutto'];
			$total_vat += $cc ['total_vat'];
			$vats_summary .= $cc ['ecmvat_value'] . '%:' . $cc ['total_netto'] . ':' . $cc ['total_vat'] . ':' . $cc ['total_brutto'] . ',';
		}
		$res = $GLOBALS ['db']->query ( "update ecminvoiceouts set vats_summary='" . $vats_summary . "',total_netto='" . $total_netto . "',total_vat='" . $total_vat . "',
	           total_brutto='" . $total_brutto . "' where id='" . $id . "'" );
	}
	function calculateTotals($id) {
		$vats_summary = '';
		$total_netto = 0;
		$total_brutto = 0;
		$total_vat = 0;
		
		$res = $GLOBALS ['db']->query ( "select ROUND(sum(total_netto),2) AS total_netto,ROUND(sum((total_netto*ecmvat_value)/100),2) AS total_vat,
ROUND(sum(((total_netto*ecmvat_value)/100)+total_netto),2) AS total_brutto,ecmvat_value
from ecminvoiceoutitems where ecminvoiceout_id='" . $id . "' group by ecmvat_id" );
		while ( $cc = $GLOBALS ['db']->fetchByAssoc ( $res ) ) {
			$total_netto += $cc ['total_netto'];
			$total_brutto += $cc ['total_brutto'];
			$total_vat += $cc ['total_vat'];
			$vats_summary .= $cc ['ecmvat_value'] . '%:' . $cc ['total_netto'] . ':' . $cc ['total_vat'] . ':' . $cc ['total_brutto'] . ',';
		}
		$res = $GLOBALS ['db']->query ( "update ecminvoiceouts set vats_summary='" . $vats_summary . "',total_netto='" . $total_netto . "',total_vat='" . $total_vat . "',
	           total_brutto='" . $total_brutto . "' where id='" . $id . "'" );
	}
	
	// ***************************Start Managing Positions*************************//
	function constructInsertQuery($data, $table = '') {
		if ($table == '' && isset ( $this->object_name ) && $this->object_name != '') {
			$table = strtolower ( $this->object_name ) . "items";
		} else
			return "";
		$keys = array ();
		$values = array ();
		foreach ( $data as $key => $value ) {
			$keys [] = $key;
			if (is_array ( $value ))
				$values [] = $value [1] . str_replace ( "'", "\'", $value [0] ) . $value [1];
			else
				$values [] = "'" . str_replace ( "'", "\'", $value ) . "'";
		}
		$q = "insert into `$table` (`";
		$q .= implode ( '`, `', $keys );
		$q .= "`) values (";
		$q .= implode ( ", ", $values );
		$q .= ");";
		return $q;
	}
	function savePositions($id = null, $position_list = null) {
		global $current_user, $timedate;
		if ($position_list == null)
			$position_list = $this->position_list;
		if ($id == null)
			$id = $this->id;
		if (count ( $position_list ) > 0)
			$this->deleteAssignedPositions ( $id );
		$arr = array ();
		$position = 0;
		$counter = 0;
		for($i = 0; $i < count ( $position_list ); $i ++) {
			if ($position_list [$i] ['name'] == '')
				continue;
			$p = $position_list [$i];
			if (! empty ( $p ['category_id'] ) || $p ['category_id'] == '') {
				require_once ("modules/EcmProducts/EcmProduct.php");
				$pr = new EcmProduct ();
				$pr->retrieve ( $p ['id'] );
				$p ['category_id'] = $pr->product_category_id;
			}
			if ($p ['product_item_id'] != '' && $p ['product_item'] == 'false') {
				if ($position_list [$i] ['quantity'] != $position_list [$i + 1] ['quantity'] || $position_list [$i] ['price_start'] != $position_list [$i + 1] ['price_start'] || $position_list [$i] ['price_netto'] != $position_list [$i + 1] ['price_netto']) {
					$arr = array (
							'id' => create_guid (),
							'date_entered' => array (
									'NOW()',
									'' 
							),
							'date_modified' => array (
									'NOW()',
									'' 
							),
							'modified_user_id' => $current_user->id,
							'assigned_user_id' => $current_user->id,
							'created_by' => $current_user->id,
							'deleted' => '0',
							strtolower ( $this->object_name ) . '_id' => $id,
							'ecmproduct_id' => $p ['product_id'],
							'position' => $counter,
							'code' => $p ['product_code'],
							'name' => $p ['name'],
							'quantity' => ((empty ( $p ['quantity'] ) || $p ['quantity'] == '') ? 0 : $p ['quantity']),
							'price_start' => ((empty ( $p ['price_start'] ) || $p ['price_start'] == '') ? 0 : $p ['price_start']),
							'price_netto' => ((empty ( $p ['price_netto'] ) || $p ['price_netto'] == '') ? 0 : $p ['price_netto']),
							'discount' => ((empty ( $p ['discount'] ) || $p ['discount'] == '') ? 0 : $p ['discount']),
							'total_netto' => ((empty ( $p ['total_netto'] ) || $p ['total_netto'] == '') ? 0 : $p ['total_netto']),
							'total_brutto' => ((empty ( $p ['total_brutto'] ) || $p ['total_brutto'] == '') ? 0 : $p ['total_brutto']),
							'total_vat' => ((empty ( $p ['total_vat'] ) || $p ['total_vat'] == '') ? 0 : $p ['total_vat']),
							'price_brutto' => ((empty ( $p ['price_brutto'] ) || $p ['price_brutto'] == '') ? 0 : $p ['price_brutto']),
							'dd_unit_id' => $p ['unit_id'],
							'dd_unit_name' => $p ['unit_name'],
							'ecmvat_id' => $p ['ecmvat_id'],
							'ecmvat_name' => $p ['ecmvat_name'],
							'ecmvat_value' => $p ['ecmvat_value'],
							'ecmproductcategory_id' => $p ['category_id'],
							'recipient_code' => $p ['recipient_code'],
							'ecminvoiceoutitem_id' => $p ['product_item_id'],
							'old_ecminvoiceoutitem_id' => $p ['product_itemold_id'],
							'old_total_netto' => $position_list [$i + 1] ['total_netto'],
							'old_total_vat' => $position_list [$i + 1] ['total_vat'],
							'old_total_brutto' => $position_list [$i + 1] ['total_brutto'],
							'old_quantity' => $position_list [$i + 1] ['quantity'],
							'quantity_corrected' => round ( floatval ( $position_list [$i] ['quantity'] ) - floatval ( $position_list [$i + 1] ['quantity'] ), 2 ),
							'total_netto_corrected' => round ( floatval ( $position_list [$i] ['total_netto'] ) - floatval ( $position_list [$i + 1] ['total_netto'] ), 2 ),
							'total_brutto_corrected' => round ( floatval ( $position_list [$i] ['total_brutto'] ) - floatval ( $position_list [$i + 1] ['total_brutto'] ), 2 ) 
					);
					$this->db->query ( $this->constructInsertQuery ( $arr ) );
					$counter ++;
				} else {
					continue;
				}
			} else if ($p ['product_item_id'] == '' && $p ['product_item'] == 'true') {
				continue;
			} else {
				$item_id = create_guid ();
				$arr = array (
						'id' => $item_id,
						'date_entered' => array (
								'NOW()',
								'' 
						),
						'date_modified' => array (
								'NOW()',
								'' 
						),
						'modified_user_id' => $current_user->id,
						'assigned_user_id' => $current_user->id,
						'created_by' => $current_user->id,
						'deleted' => '0',
						strtolower ( $this->object_name ) . '_id' => $id,
						'ecmproduct_id' => $p ['product_id'],
						'position' => $position,
						'code' => $p ['product_code'],
						'name' => $p ['name'],
						'quantity' => ((empty ( $p ['quantity'] ) || $p ['quantity'] == '') ? 0 : $p ['quantity']),
						'price_start' => ((empty ( $p ['price_start'] ) || $p ['price_start'] == '') ? 0 : $p ['price_start']),
						'price_netto' => ((empty ( $p ['price_netto'] ) || $p ['price_netto'] == '') ? 0 : $p ['price_netto']),
						'discount' => ((empty ( $p ['discount'] ) || $p ['discount'] == '') ? 0 : $p ['discount']),
						'total_netto' => ((empty ( $p ['total_netto'] ) || $p ['total_netto'] == '') ? 0 : $p ['total_netto']),
						'total_brutto' => ((empty ( $p ['total_brutto'] ) || $p ['total_brutto'] == '') ? 0 : $p ['total_brutto']),
						'total_vat' => ((empty ( $p ['total_vat'] ) || $p ['total_vat'] == '') ? 0 : $p ['total_vat']),
						'price_brutto' => ((empty ( $p ['price_brutto'] ) || $p ['price_brutto'] == '') ? 0 : $p ['price_brutto']),
						'dd_unit_id' => $p ['unit_id'],
						'dd_unit_name' => $p ['unit_name'],
						'ecmvat_id' => $p ['ecmvat_id'],
						'ecmvat_name' => $p ['ecmvat_name'],
						'ecmvat_value' => $p ['ecmvat_value'],
						'ecmproductcategory_id' => $p ['category_id'],
						'recipient_code' => $p ['recipient_code'] 
				);
				$this->db->query ( $this->constructInsertQuery ( $arr ) );
				if ($this->stock_id != '' && $this->wz_id == '')
					$this->addProducts ( $arr, $id, $item_id );
				$position ++;
			}
		}
	}
	function addProducts($p, $id, $itemid) {
		$arr = array ();
		if ($p ['ecmproductcategory_id'] == 'bf900339-6c7b-f278-2737-542023796730')
			continue;
		$w = $GLOBALS ['db']->query ( "select quantity as qty,id,price from ecmstockoperations where deleted='0' and type='0' and in_id IS NULL and stock_id='" . $this->stock_id . "' and product_id='" . $p ['ecmproduct_id'] . "' and used='0'" );
		while ( $rrr = $GLOBALS ['db']->fetchByAssoc ( $w ) ) {
			$ww = $GLOBALS ['db']->query ( "select quantity from ecmstockoperations where in_id='" . $rrr ['id'] . "' and type='1' and in_id IS NOT NULL and stock_id='" . $this->stock_id . "' and product_id='" . $p ['ecmproduct_id'] . "' and deleted='0'" );
			$rqty = 0;
			while ( $rrp = $GLOBALS ['db']->fetchByAssoc ( $ww ) ) {
				$rqty += $rrp ['quantity'];
			}
			$qty = $rrr ['qty'] - $rqty;
			if ($qty > 0) {
				$arr [] = array (
						"qty" => $qty,
						"id" => $rrr ['id'],
						"price" => $rrr ['price'] 
				);
			}
		}
		$rr = array ();
		$used_qty = 0;
		$stop = 0;
		foreach ( $arr as $value ) {
			if ($p ['quantity'] - $used_qty <= $value ['qty']) {
				$rr [] = array (
						"id" => $value ['id'],
						"qty" => $p ['quantity'] - $used_qty,
						"price" => $value ['price'] 
				);
				$stop = 1;
			} else {
				$rr [] = array (
						"id" => $value ['id'],
						"qty" => $value ['qty'],
						"price" => $value ['price'] 
				);
				$used_qty += $value ['qty'];
			}
			if ($stop) {
				$stop = 0;
				break;
			}
		}
		$avg_pq = 0;
		$avg_q = 0;
		foreach ( $rr as $r ) {
			$this->addProductToStockOut ( $r ['id'], $p ['ecmproduct_id'], $r ['qty'], $r ['price'], $this->register_date, $id, $this->stock_id, $itemid );
			$avg_pq += $r ['qty'] * $r ['price'];
			$avg_q += $r ['qty'];
		}
		// $GLOBALS['db']->query("update ecminvoiceoutitems set price_start='".($avg_pq/$avg_q)."',total_netto='".$avg_pq."' where id='".$itemid."'");
	}
	function addProductToStockOut($stock_in_id, $product_id, $quantity, $price, $date, $mm_id, $stock_id, $itemid) {
		require_once ("modules/EcmStockOperations/EcmStockOperation.php");
		$o = new EcmStockOperation ();
		$o->unformat_all_fields ();
		
		require_once ("modules/EcmProducts/EcmProduct.php");
		$o->product_id = $product_id;
		$p = new EcmProduct ();
		$p->retrieve ( $product_id );
		$o->product_code = $p->code;
		$o->product_name = $p->name;
		
		require_once ("modules/EcmStocks/EcmStock.php");
		$o->stock_id = $stock_id;
		$s = new EcmStock ();
		$s->retrieve ( $stock_id );
		$o->stock_name = $s->name;
		
		$o->parent_id = $mm_id;
		$r = $GLOBALS ['db']->fetchByAssoc ( $GLOBALS ['db']->query ( "select document_no from ecminvoiceouts where id='" . $mm_id . "'" ) );
		$o->parent_name = $r ['document_no'];
		$o->parent_type = "EcmInvoiceOuts";
		
		$o->quantity = $quantity;
		$o->price = $price;
		$o->in_id = $stock_in_id;
		$o->documentitem_id = $itemid;
		$o->type = 1;
		$oid = $o->save ();
		$GLOBALS ['db']->query ( "update ecmstockoperations set price='" . $price . "' where id='" . $oid . "'" );
		
		require_once ("modules/EcmStockStates/EcmStockState.php");
		$ss = new EcmStockState ();
		$ss->UpdateStockState ( $o->stock_id, $o->product_id );
	}
	function getCorrectedPosition($position, $type) {
		$query = "SELECT * FROM `" . strtolower ( $this->object_name ) . "items` WHERE `id`='" . $position . "' order by position asc";
		$r = $this->db->query ( $query );
		$return_array = array ();
		if ($r) {
			while ( $position = $this->db->fetchByAssoc ( $r ) ) {
				if (! is_array ( $position ))
					return '';
				global $timedate;
				$return_array = array ();
				$return_array ['product_id'] = $position ['ecmproduct_id'];
				$return_array ['position'] = $position ['position'];
				$return_array ['product_code'] = $position ['code'];
				$return_array ['name'] = $position ['name'];
				$return_array ['quantity'] = $position ['quantity'];
				$return_array ['price_start'] = $position ['price_start'];
				$return_array ['price_netto'] = $position ['price_netto'];
				$return_array ['discount'] = $position ['discount'];
				$return_array ['total_netto'] = $position ['total_netto'];
				$return_array ['unit_id'] = $position ['dd_unit_id'];
				$return_array ['unit_name'] = $position ['dd_unit_name'];
				$return_array ['ecmvat_id'] = $position ['ecmvat_id'];
				$return_array ['ecmvat_name'] = $position ['ecmvat_name'];
				$return_array ['ecmvat_value'] = $position ['ecmvat_value'];
				$return_array ['recipient_code'] = $position ['recipient_code'];
				$return_array ['remarks'] = $position ['remarks'];
				$return_array ['old_ecminvoiceoutitem_id'] = $position ['old_ecminvoiceoutitem_id'];
				$return_array ['old_total_netto'] = $position ['old_total_netto'];
				$return_array ['old_total_brutto'] = $position ['old_total_brutto'];
				$return_array ['old_quantity'] = $position ['old_quantity'];
				$return_array ['old_total_vat'] = $position ['old_total_vat'];
				$return_array ['ecminvoiceoutitem_id'] = $position ['ecminvoiceoutitem_id'];
				$return_array ['total_vat'] = $position ['total_vat'];
				$return_array ['total_brutto'] = $position ['total_brutto'];
				
				if ($type == "true") {
					$return_array ['product_item_id'] = $position ['id'];
					$return_array ['product_item'] = "true";
					// get values from previous corrects
					
					$cc = $GLOBALS ['db']->fetchByAssoc ( $GLOBALS ['db']->query ( "SELECT ii.id,ii.price_start, ii.price_netto, ii.quantity, ii.discount,
						ii.ecmvat_value, ii.ecmvat_id, ii.ecmvat_name FROM ecminvoiceoutitems as ii
						 INNER JOIN ecminvoiceouts AS i ON i.id=ii.ecminvoiceout_id WHERE i.canceled is null and ii.ecminvoiceoutitem_id='" . $position ['id'] . "' ORDER BY ii.date_entered DESC LIMIT 0,1" ) );
					if ($cc ['price_netto']) {
						$return_array ['price_start'] = $cc ['price_start'];
						$return_array ['price_netto'] = $cc ['price_netto'];
						$return_array ['quantity'] = $cc ['quantity'];
						$return_array ['discount'] = $cc ['discount'];
						$return_array ['ecmvat_value'] = $cc ['ecmvat_value'];
						$return_array ['ecmvat_id'] = $cc ['ecmvat_id'];
						$return_array ['ecmvat_name'] = $cc ['ecmvat_name'];
						$return_array ['product_itemold_id'] = $cc ['id'];
					}
				} else {
					$return_array ['product_item_id'] = $position ['ecminvoiceoutitem_id'];
				}
				
				if ($type == "1") {
					$return_array ['product_item_id'] = $position ['id'];
					$return_array ['product_item'] = "false";
					// get values from previous corrects
					
					$cc = $GLOBALS ['db']->fetchByAssoc ( $GLOBALS ['db']->query ( "SELECT ii.id,ii.price_start, ii.price_netto, ii.quantity, ii.discount,
						ii.ecmvat_value, ii.ecmvat_id, ii.ecmvat_name FROM ecminvoiceoutitems as ii
						 INNER JOIN ecminvoiceouts AS i ON i.id=ii.ecminvoiceout_id WHERE i.canceled is null and ii.ecminvoiceoutitem_id='" . $position ['id'] . "' ORDER BY ii.date_entered DESC LIMIT 0,1" ) );
					if ($cc ['price_netto']) {
						$return_array ['price_start'] = $cc ['price_start'];
						$return_array ['price_netto'] = $cc ['price_netto'];
						$return_array ['quantity'] = $cc ['quantity'];
						$return_array ['discount'] = $cc ['discount'];
						$return_array ['ecmvat_value'] = $cc ['ecmvat_value'];
						$return_array ['ecmvat_id'] = $cc ['ecmvat_id'];
						$return_array ['ecmvat_name'] = $cc ['ecmvat_name'];
						$return_array ['product_itemold_id'] = $cc ['id'];
					}
				} else {
					$return_array ['product_item_id'] = $position ['ecminvoiceoutitem_id'];
				}
			}
		}
		return $return_array;
	}
	function getPosition($position, $type) {
		if (! is_array ( $position ))
			return '';
		global $timedate;
		$return_array = array ();
		$return_array ['product_id'] = $position ['ecmproduct_id'];
		$return_array ['position'] = $position ['position'];
		$return_array ['product_code'] = $position ['code'];
		$return_array ['name'] = $position ['name'];
		$return_array ['quantity'] = $position ['quantity'];
		$return_array ['price_start'] = $position ['price_start'];
		$return_array ['price_netto'] = $position ['price_netto'];
		$return_array ['discount'] = $position ['discount'];
		$return_array ['total_netto'] = $position ['total_netto'];
		$return_array ['unit_id'] = $position ['dd_unit_id'];
		$return_array ['unit_name'] = $position ['dd_unit_name'];
		$return_array ['ecmvat_id'] = $position ['ecmvat_id'];
		$return_array ['ecmvat_name'] = $position ['ecmvat_name'];
		$return_array ['ecmvat_value'] = $position ['ecmvat_value'];
		$return_array ['recipient_code'] = $position ['recipient_code'];
		$return_array ['remarks'] = $position ['remarks'];
		$return_array ['old_ecminvoiceoutitem_id'] = $position ['old_ecminvoiceoutitem_id'];
		$return_array ['old_total_netto'] = $position ['old_total_netto'];
		$return_array ['old_total_brutto'] = $position ['old_total_brutto'];
		$return_array ['old_quantity'] = $position ['old_quantity'];
		$return_array ['old_total_vat'] = $position ['old_total_vat'];
		$return_array ['ecminvoiceoutitem_id'] = $position ['ecminvoiceoutitem_id'];
		$return_array ['total_vat'] = $position ['total_vat'];
		$return_array ['total_brutto'] = $position ['total_brutto'];
		
		if ($type == "true") {
			$return_array ['product_item_id'] = $position ['id'];
			$return_array ['product_item'] = "true";
			// get values from previous corrects
			
			$cc = $GLOBALS ['db']->fetchByAssoc ( $GLOBALS ['db']->query ( "SELECT ii.id,ii.price_start, ii.price_netto, ii.quantity, ii.discount,
						ii.ecmvat_value, ii.ecmvat_id, ii.ecmvat_name FROM ecminvoiceoutitems as ii
						 INNER JOIN ecminvoiceouts AS i ON i.id=ii.ecminvoiceout_id WHERE i.canceled is null and ii.ecminvoiceoutitem_id='" . $position ['id'] . "' ORDER BY ii.date_entered DESC LIMIT 0,1" ) );
			if ($cc ['price_netto']) {
				$return_array ['price_start'] = $cc ['price_start'];
				$return_array ['price_netto'] = $cc ['price_netto'];
				$return_array ['quantity'] = $cc ['quantity'];
				$return_array ['discount'] = $cc ['discount'];
				$return_array ['ecmvat_value'] = $cc ['ecmvat_value'];
				$return_array ['ecmvat_id'] = $cc ['ecmvat_id'];
				$return_array ['ecmvat_name'] = $cc ['ecmvat_name'];
				$return_array ['product_itemold_id'] = $cc ['id'];
			}
		} else {
			$return_array ['product_item_id'] = $position ['ecminvoiceoutitem_id'];
		}
		
		if ($type == "1") {
			$return_array ['product_item_id'] = $position ['id'];
			$return_array ['product_item'] = "false";
			// get values from previous corrects
			
			$cc = $GLOBALS ['db']->fetchByAssoc ( $GLOBALS ['db']->query ( "SELECT ii.id,ii.price_start, ii.price_netto, ii.quantity, ii.discount,
						ii.ecmvat_value, ii.ecmvat_id, ii.ecmvat_name FROM ecminvoiceoutitems as ii
						 INNER JOIN ecminvoiceouts AS i ON i.id=ii.ecminvoiceout_id WHERE i.canceled is null and ii.ecminvoiceoutitem_id='" . $position ['id'] . "' ORDER BY ii.date_entered DESC LIMIT 0,1" ) );
			if ($cc ['price_netto']) {
				$return_array ['price_start'] = $cc ['price_start'];
				$return_array ['price_netto'] = $cc ['price_netto'];
				$return_array ['quantity'] = $cc ['quantity'];
				$return_array ['discount'] = $cc ['discount'];
				$return_array ['ecmvat_value'] = $cc ['ecmvat_value'];
				$return_array ['ecmvat_id'] = $cc ['ecmvat_id'];
				$return_array ['ecmvat_name'] = $cc ['ecmvat_name'];
				$return_array ['product_itemold_id'] = $cc ['id'];
			}
		} else {
			$return_array ['product_item_id'] = $position ['ecminvoiceoutitem_id'];
		}
		return $return_array;
	}
	function getPositionList($array = false, $type = "no") {
		if (isset ( $this->id ) && $this->id != '') {
			$query = "SELECT * FROM `" . strtolower ( $this->object_name ) . "items` WHERE `" . strtolower ( $this->object_name ) . "_id`='" . $this->id . "' order by position asc";
			$r = $this->db->query ( $query );
			$return_array = array ();
			if ($r) {
				while ( $w = $this->db->fetchByAssoc ( $r ) ) {
					$a = "no";
					if ($type == "true") {
						$a = 1;
					}
					$return_array [] = $this->getPosition ( $w, $a );
					if ($type == "true") {
						$return_array [] = $this->getPosition ( $w, $type );
					}
				}
				$json = getJSONobj ();
				return $array ? $return_array : $json->encode ( $return_array );
			}
		}
		return $array ? false : '[]';
	}
	function deleteAssignedPositions() {
		if (isset ( $this->id ) && $this->id != '') {
			$query = "DELETE FROM `" . strtolower ( $this->object_name ) . "items` WHERE `" . strtolower ( $this->object_name ) . "_id`='" . $this->id . "'";
			$r = $this->db->query ( $query );
			if ($r)
				return true;
		}
		return false;
	}
	function formatPositions($position_list) {
		return;
		if (! is_array ( $position_list ) || count ( $position_list ) == 0)
			return false;
		global $app_list_strings;
		require_once ('modules/Currencies/Currency.php');
		foreach ( $position_list as $key => $value ) {
			$position_list [$key] ['unit_id'] = $app_list_strings ['ecmproducts_unit_dom'] [$value ['unit_id']];
			$position_list [$key] ['category_id'] = $app_list_strings ['ecmproducts_category_dom'] [$value ['category_id']];
			// $position_list[$key]['vat_id'] = format_number($value['vat_id']).'%';
			$position_list [$key] ['discount'] = format_number ( $value ['discount'] ) . '%';
			if (isset ( $currency ) && ($currency->id == $this->currency_id)) {
			} else {
				$currency = new Currency ();
				$currency->retrieve ( $this->currency_id );
			}
			$position_list [$key] ['price'] = format_number ( $value ['price'] ) . ' ' . $currency->iso4217;
			$position_list [$key] ['total'] = format_number ( $value ['total'] ) . ' ' . $currency->iso4217;
			// $position_list[$key]['price'] = format_number($value['price']).' PLN';
			// $position_list[$key]['total'] = format_number($value['total']).' PLN';
			$this->currency_symbol = $currency->iso4217;
		}
		return $position_list;
	}
	// ***************************End Managing Positions*************************//
	function ACLAccess($view, $is_owner = 'not_set') {
		global $current_user;
		$file = 'modules/EcmGroupSales/EcmGroupSale.php';
		if (file_exists ( $file )) {
			require_once ($file);
			$cc = EcmGroupSale::loadSettings ( true );
		} else
			return true;
		if (is_admin ( $current_user )) {
			switch ($view) {
				case 'confirming' :
					return ($this->status == "s20");
				case 'send_to_confirm' :
					return ($this->status == "s10");
				case 'pdf_toolbar' :
					return ($this->status != "s10" && $this->status != "s20" && $this->status != "s40");
			}
			return true;
		}
		if ($is_owner == 'not_set') {
			$is_owner = $this->isOwner ( $current_user->id );
		}
		// if we don't implent acls return true
		if (! $this->bean_implements ( 'ACL' ))
			return true;
		$view = strtolower ( $view );
		if ($cc ['user_manager_role']) { // Manager
			switch ($view) {
				case 'list' :
				case 'index' :
				case 'listview' :
					return ACLController::checkAccess ( $this->module_dir, 'list', true );
				case 'edit' :
				case 'save' :
				case 'popupeditview' :
				case 'editview' :
					return (ACLController::checkAccess ( $this->module_dir, 'edit', $is_owner ));
				case 'view' :
				case 'detail' :
				case 'detailview' :
					return ACLController::checkAccess ( $this->module_dir, 'view', $is_owner );
				case 'delete' :
					return ACLController::checkAccess ( $this->module_dir, 'delete', $is_owner );
				case 'export' :
					return ACLController::checkAccess ( $this->module_dir, 'export', $is_owner );
				case 'import' :
					return ACLController::checkAccess ( $this->module_dir, 'import', true );
				case 'send_to_confirm' :
					return ($this->status == "s10");
				case 'can_commit' :
					return true;
				case 'confirming' :
					return ($this->status == "s20");
				case 'auto_commiting' :
					return true;
				case 'pdf_toolbar' :
					return ($this->status != "s10" && $this->status != "s20" && $this->status != "s40");
			}
		} else if ($cc ['user_representative_extra_role']) { // Representative Extra
			switch ($view) {
				case 'list' :
				case 'index' :
				case 'listview' :
					return ACLController::checkAccess ( $this->module_dir, 'list', true );
				case 'edit' :
					return (ACLController::checkAccess ( $this->module_dir, 'edit', $is_owner ) && ($this->status == "s10" || $this->status == "s40"));
				case 'save' :
				case 'popupeditview' :
				case 'editview' :
					return (ACLController::checkAccess ( $this->module_dir, 'edit', $is_owner ));
				case 'view' :
				case 'detail' :
				case 'detailview' :
					return ACLController::checkAccess ( $this->module_dir, 'view', $is_owner );
				case 'delete' :
					return (ACLController::checkAccess ( $this->module_dir, 'delete', $is_owner ) && $this->status == "s10");
				case 'export' :
					return ACLController::checkAccess ( $this->module_dir, 'export', $is_owner );
				case 'import' :
					return ACLController::checkAccess ( $this->module_dir, 'import', true );
				case 'quote_to_sale' :
				case 'quote_to_invoice' :
					return ($this->status != "s10" && $this->status != "s20" && $this->status != "s40" && $this->status != "s60");
				case 'send_to_confirm' :
					return ($this->status == "s10");
				case 'send_email' :
					return ($this->status != "s10" && $this->status != "s20" && $this->status != "s40");
				case 'can_commit' :
					return true;
				case 'confirming' :
					return false;
				case 'auto_commiting' :
					return true;
				case 'pdf_toolbar' :
					return ($this->status != "s10" && $this->status != "s20" && $this->status != "s40");
			}
		} else if ($cc ['user_representative_role']) { // Representative
			switch ($view) {
				case 'list' :
				case 'index' :
				case 'listview' :
					return ACLController::checkAccess ( $this->module_dir, 'list', true );
				case 'edit' :
					return (ACLController::checkAccess ( $this->module_dir, 'edit', $is_owner ) && ($this->status == "s10" || $this->status == "s40"));
				case 'save' :
				case 'popupeditview' :
				case 'editview' :
					return (ACLController::checkAccess ( $this->module_dir, 'edit', $is_owner ));
				case 'view' :
				case 'detail' :
				case 'detailview' :
					return ACLController::checkAccess ( $this->module_dir, 'view', $is_owner );
				case 'delete' :
					return (ACLController::checkAccess ( $this->module_dir, 'delete', $is_owner ) && $this->status == "s10");
				case 'export' :
					return ACLController::checkAccess ( $this->module_dir, 'export', $is_owner );
				case 'import' :
					return ACLController::checkAccess ( $this->module_dir, 'import', true );
				case 'quote_to_sale' :
				case 'quote_to_invoice' :
					return ($this->status != "s10" && $this->status != "s20" && $this->status != "s40" && $this->status != "s60");
				case 'send_to_confirm' :
					return ($this->status == "s10");
				case 'send_email' :
					return ($this->status != "s10" && $this->status != "s20" && $this->status != "s40");
				case 'can_commit' :
					return false;
				case 'confirming' :
					return false;
				case 'auto_commiting' :
					return false;
				case 'pdf_toolbar' :
					return ($this->status != "s10" && $this->status != "s20" && $this->status != "s40");
			}
		}
		// if it is not one of the above views then it should be implemented on the page level
		return true;
	}
	
	// mz generate number
	function generateNumber($stock_id,$date) {
		$db = $GLOBALS ['db'];
		$r = $db->fetchByAssoc ( $db->query ( "SELECT count(id) as c FROM ecminvoiceouts WHERE deleted='0' AND YEAR(register_date)='" .date('Y',strtotime($date)) . "' and type='normal' and stock_id='" . $stock_id . "'" ) );
		
		if (! $r || ! $r ['c'] || $r ['c'] == '')
			$count = 0;
		else
			$count = intval ( $r ['c'] );
		
		$count ++;
		
		// has 5 digits?
		$tmp = strval ( $count );
		while ( strlen ( $tmp ) < 5 )
			$tmp = '0' . $tmp;
		
		return date('Ymd',strtotime($date)). $tmp;
	}
	function generateNumberCorrect() {
		$db = $GLOBALS ['db'];
		$r = $db->fetchByAssoc ( $db->query ( "SELECT count(id) as c FROM ecminvoiceouts WHERE deleted='0' AND YEAR(register_date)='" . date ( 'Y' ) . "' and type='correct'" ) );
		
		if (! $r || ! $r ['c'] || $r ['c'] == '')
			$count = 0;
		else
			$count = intval ( $r ['c'] );
		
		$count ++;
		
		// has 5 digits?
		$tmp = strval ( $count );
		while ( strlen ( $tmp ) < 5 )
			$tmp = '0' . $tmp;
		
		return date ( "Ymd" ) . $tmp;
	}
	function formatNumber($number, $stock_id) {
		$db = $GLOBALS ['db'];
		$st = $db->fetchByAssoc ( $db->query ( "select no from ecmstocks where id='" . $stock_id . "'" ) );
		$n = intval ( substr ( $number, 8, 5 ) );
		$y = substr ( $number, 0, 4 );
		
		// has 3 digits?
		while ( strlen ( $n ) < 3 )
			$n = '0' . $n;
		if ($st ['no'] != '')
			return '' . $n . '/' . $st ['no'] . '/' . $y;
		else
			return '' . $n . '/' . $y;
	}
	function formatNumberCorrect($number) {
		$n = intval ( substr ( $number, 8, 5 ) );
		$y = substr ( $number, 0, 4 );
		
		// has 3 digits?
		while ( strlen ( $n ) < 3 )
			$n = '0' . $n;
		
		return 'FKKOR ' . $n . '/' . $y;
	}
}
?>